<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: widget/Inputbox.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: widget/Inputbox.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * @license
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2014 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(['jquery', 'underscore', 'uweaver/lang',
    'uweaver/widget/Widget', 'uweaver/widget/Tooltips', 'uweaver/browser', 'uweaver/exception/Violation',
    'uweaver/exception/UnsupportedTypeException'], function ($, _, lang, Widget, Tooltips, browser, Violation, UnsupportedTypeException){
    var declare = lang.declare;
    var Base = Widget;

    var SUPPORTEDTYPES = ['text', 'password', 'textarea'];
    var SUPPORTEDDATATYPES = ['text'];
    var VALIDATIONERRORS = {
        'valueMissing': null,
        'typeMismatch': 'type',
        'patternMismatch': 'pattern',
        'tooLong': 'maxLength',
        'tooShort': 'minLength',
        'rangeUnderFlow': 'min',
        'rangeOverflow': 'max',
        'stepMismatch': 'step',
        'badInput': null};

    /**
     * A Inputbox is a widget for ....
     *
     * ##### Events:
     * + 'change' - [value()]{@link Inputbox#value}
     *
     * @constructor Inputbox
     * @extends Widget
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [config] - A map of configuration to pass to the constructor.
     * @param {String} config.name - A text string to specify the name. Required.
     * @param {String} [config.value] - Specifies the value of an &lt;input> element.
     * @param {Boolean} [config.readonly=false] - Specifies that an input field is read-only.
     * @param {Boolean} [config.required=false] - Specifies that an input field must be filled out.
     * @param {Boolean} [config.disabled=false] - Specifies that an &lt;input> element should be disabled.
     * @param {Integer} [config.max] - Specifies the maximum value for an &lt;input> element.
     * @param {Integer} [config.min] - Specifies a minimum value for an &lt;input> element.
     * @param {Integer} [config.step=1] - Specifies the legal number intervals for an input field.
     * @param {Integer} [config.maxLength=524288] - Specifies the maximum number of characters allowed in the &lt;input> element.
     * @param {Integer} [config.minLength=0] - Specifies the minimum number of characters allowed in the &lt;input> element.
     */
    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        var defaults = {};
        var cfg = this._cfg;

        _.defaults(cfg, defaults);

        this._anchors = {};

        var tooltips = new Tooltips({
            target: this
        }).render();

        this._tooltips = tooltips;

        var $input = this.$el;

        $input.on('change', _.bind(onChange, this));

        (cfg.type!==undefined) &amp;&amp; this.type(cfg.type);
        (cfg.dataType!==undefined) &amp;&amp; this.dataType(this, cfg.dataType);
        (cfg.dataPattern!==undefined) &amp;&amp; this.dataPattern(this, cfg.dataPattern);
        (cfg.readonly!==undefined) &amp;&amp; this.readonly(cfg.readonly);
        (cfg.required!==undefined) &amp;&amp; this.required(cfg.required);
        (cfg.disabled!==undefined) &amp;&amp; this.disabled(cfg.disabled);
        (cfg.max!==undefined) &amp;&amp; this.max(cfg.max);
        (cfg.min!==undefined) &amp;&amp; this.min(cfg.min);
        (cfg.step!==undefined) &amp;&amp; this.step(cfg.step);
        (cfg.maxLength!==undefined) &amp;&amp; this.maxLength(cfg.maxLength);
        (cfg.minLength!==undefined) &amp;&amp; this.minLength(cfg.minLength);
        
        this.type(this.type()); this.dataType(this.dataType());

        this.clearValidation();
    }
    
    function onChange(event) {
        this.validate() &amp;&amp; this.change();
    }

    /**
     * Get or set the value.
     *
     * @param {String} value
     * @returns {*|undefined}
     */
    function value(value, options) {
        options || (options = {});
        var $input = this.$el;
        var text = $input.val();
        
        var currentValue = this.parse(text);

        if(arguments.length===0) return currentValue;

        (value===undefined) &amp;&amp; (value=null);

        if(value===currentValue) return;

        $input.val(this.format(value));

        this.validate() &amp;&amp; (options.silent || this.change());
    }
    
    function clear() {
        var $input = this.$el;
        $input.val(null);
        this.clearValidation();
    }

    /**
     * 
     * Format the the value and return a text to display in the inputbox.
     *
     * @memberof Inputbox#
     * @protected
     * @param value
     * @returns {*}
     */
    function format(value) {
        return value;
    }

    /**
     * Parse the text of the inputbox and return a value.
     *
     * @memberof Inputbox#
     * @protected
     */
    function parse(text) {
        var value;

        if(text===undefined||text.trim()==='') {
            value = null;
        } else {
            value = text;
        }

        return value;
    }


    /**
     * Validate the value of the inputbox.
     */
    function validate() {
        var $input = this.$el;
        var validity = $input.prop('validity');
        var valid = true;

        this.clearValidation();

        (valid &amp;&amp; _.isObject(validity)) &amp;&amp; (valid = this.checkValidity());

        (valid &amp;&amp; this.useCustomType()) &amp;&amp; (valid = this.customValidate());

        return valid;
    }

    function change() {
        this.trigger('change', {
            data: this.value(),
            context: this,
            source: this
        });
    }

    function checkValidity() {
        var $input = this.$el;
        var validity = $input.prop('validity');

        if(!validity.valid) {
            _.each(VALIDATIONERRORS, function(prop, error) {
                if(validity[error]) {
                    var parameters = [];
                    if(prop) {
                        parameters.push($input.prop(prop)||$input.attr(prop));
                    }
                    this.violate(new Violation({
                        properties: [this.name()],
                        error: error.toUpperCase(),
                        parameters: parameters
                    }));
                }
            }, this);

            var validationMessage = "";
            _.each(this._violations, function(violation) {
                validationMessage = validationMessage + '\n' + violation.toString();
            });
            $input.get(0).setCustomValidity(validationMessage);
        }


        return validity.valid;
    }

    function customValidate() {
        return true;
    }

    function name(name) {
        var $input = this.$el;

        if(!name) return $input.attr('name');

        $input.attr('name', name);
    }

    function type(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.attr('type');
        if(value &amp;&amp; !_.contains(this.SUPPORTEDTYPES, value)) {
            throw new UnsupportedTypeException({
                type: value,
                supportedTypes: this.SUPPORTEDTYPES
            });
        }
        $input.attr('type', value);
    }
    
    function dataType(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.attr('data-type');
        if(value &amp;&amp; !_.contains(this.SUPPORTEDDATATYPES, value)) {
            throw new UnsupportedTypeException({
                type: value,
                supportedTypes: this.SUPPORTEDDATATYPES
            });
        }
        $input.attr('data-type', value);
    }

    function dataPattern(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.attr('data-pattern');
        $input.attr('data-pattern', value);
    }

    function useCustomType() {
        return ((!this.type()||this.type()==='')&amp;&amp;this.dataType());
    }

    function placeholder(hint) {
        var $input = this.$el;

        if(!hint) return $input.attr('placeholder');

        $input.attr('placeholder', hint);
    }

    function clearValidation() {
        this._violations = [];
        this._tooltips.content("");
        this.removeClass('uw-border-warn');
    }

    function readonly(value) {
        if(arguments.length===0) return this.el.hasAttribute('readonly');

        value ? this.el.setAttribute('readonly', null) : this.el.removeAttribute('readonly');
    }

    function required(value) {
        if(arguments.length===0) return this.el.hasAttribute('required');

        value ? this.el.setAttribute('required', null) : this.el.removeAttribute('required');
    }

    function disabled(value) {
        if(arguments.length===0) return this.el.hasAttribute('disabled');

        value ? this.el.setAttribute('disabled', null) : this.el.removeAttribute('disabled');
    }

    function max(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.prop('max');
        $input.prop('max', value);
    }

    function min(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.prop('min');
        $input.prop('min', value);
    }


    function step(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.prop('step');
        $input.prop('step', value);
    }

    function violate(violation) {

        this._violations.push(violation);

        this.hasClass('uw-border-warn') || this.addClass('uw-border-warn');

        this._tooltips.append(violation.toString() + "&lt;br>");

        return violation;
    }

    function violations() {
        return this._violations;
    }

    function state(value) {
        if(arguments.length===0) return this._state;

        this._state = value.toUpperCase();

        this.readonlyState() &amp;&amp; this.readonly(_.contains(this.readonlyState().toUpperCase().split(","), this._state));
        this.disabledState() &amp;&amp; this.disabled(_.contains(this.disabledState().toUpperCase().split(","), this._state));
        this.hiddenState() &amp;&amp; _.contains(this.hiddenState().toUpperCase().split(","), this._state) ? this.hide() : this.show();
    }

    function readonlyState(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.attr('data-readonly-state');
        $input.attr('data-readonly-state', value);
    }

    function disabledState(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.attr('data-disabled-state');
        $input.attr('data-disabled-state', value);
    }

    function hiddenState(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.attr('data-hidden-state');
        $input.attr('data-hidden-state', value);
    }

    var props = {
        /**
         * @override
         */
        tagName: 'input',

        _violations: undefined,
        _tooltips: undefined,
        _state: undefined,

        SUPPORTEDTYPES: SUPPORTEDTYPES,
        SUPPORTEDDATATYPES: SUPPORTEDDATATYPES

    };

    var Inputbox = declare(Base, {
        initialize: initialize,
        value: value,
        clear: clear,
        format: format,
        parse: parse,
        change: change,
        name: name,
        type: type,
        dataType: dataType,
        dataPattern: dataPattern,
        useCustomType: useCustomType,
        placeholder: placeholder,
        validate: validate,
        checkValidity: checkValidity,
        customValidate: customValidate,
        violate: violate,
        violations: violations,
        clearValidation: clearValidation,
        readonly: readonly,
        required: required,
        disabled: disabled,
        max: max,
        min: min,
        step: step,
        state: state,
        readonlyState: readonlyState,
        disabledState: disabledState,
        hiddenState: hiddenState
    }, props);

    return Inputbox;


});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
